/* $Id: init-sh7751rg.S,v 1.00 2002/11/08 20:00 Munakata Exp $
 *
 *  gdb-sh-stub/init-sh7751rg.S
 *
 *  Initial Register Data for SH7751RG (SH7751R 240MHz/120MHz/60MHz) 
 *  data comes from E-10 default setting
 */

#include "config.h"
#include "linkage.h"

ENTRY(init_bsc)
	mov.l	FRQCR_A,r1	/* FRQCR Address */
	mov.l	FRQCR_D,r0	/* FRQCR Data */
	mov.w	r0,@r1

	mov.l	MMUCCR_A,r1	/* MMUCCR Address */
	mov.l	MMUCCR_D,r0	/* MMUCCR Data */
	mov.w	r0,@r1

	mov.l	BCR1_A,r1	/* BCR1 Address */
	mov.l	BCR1_D,r0	/* BCR1 Data */
	mov.l	r0,@r1

	mov.l	BCR2_A,r1	/* BCR2 Address */
	mov.l	BCR2_D,r0	/* BCR2 Data */
	mov.w	r0,@r1

	mov.l	BCR3_A,r1	/* BCR3 Address */
	mov.l	BCR3_D,r0	/* BCR3 Data */
	mov.w	r0,@r1

	mov.l	BCR4_A,r1	/* BCR4 Address */
	mov.l	BCR4_D,r0	/* BCR4 Data */
	mov.l	r0,@r1

	mov.l	WCR1_A,r1	/* WCR1 Address */
	mov.l	WCR1_D,r0	/* WCR1 Data */
	mov.l	r0,@r1

	mov.l	WCR2_A,r1	/* WCR2 Address */
	mov.l	WCR2_D,r0	/* WCR2 Data */
	mov.l	r0,@r1

	mov.l	WCR3_A,r1	/* WCR3 Address */
	mov.l	WCR3_D,r0	/* WCR3 Data */
	mov.l	r0,@r1

	mov.l	PCR_A,r1	/* PCR Address */
	mov.l	PCR_D,r0	/* PCR Data */
	mov.w	r0,@r1

	mov.l	LED_A,r1	/* LED Address */
	mov	#0xff,r0	/* LED ALL 'on' */
	mov.w	r0,@r1

	mov.l	MCR_A,r1	/* MCR Address */
	mov.l	MCR_D1,r0	/* MCR Data1 */
	mov.l	r0,@r1

	! Do you need PCMCIA setting?	
	! If so, please add the lines here...

	mov.l	RTCNT_A,r1	/* RTCNT Address */
	mov.l	RTCNT_D,r0	/* RTCNT Data */
	mov.w	r0,@r1

	mov.l	RTCOR_A,r1	/* RTCOR Address */
	mov.l	RTCOR_D,r0	/* RTCOR Data */
	mov.w	r0,@r1

	mov.l	RFCR_A,r1	/* RFCR Address */
	mov.l	RFCR_D,r0	/* RFCR Data */
	mov.w	r0,@r1		/* Clear reflesh counter */

	mov.l	RTCSR_A,r1	/* RTCSR Address */
	mov.l	RTCSR_D,r0	/* RTCSR DATA */
	mov.w	r0,@r1

	mov.l	SDMR3_A,r1	/* Set SDRAM mode */
	mov	#0x55,r0
	mov.b	r0,@r1

	/* Wait DRAM refresh 30 times */
	mov.l	RFCR_A,r1	/* RFCR Address */
	mov	#30,r3
1:
	mov.w	@r1,r0
	extu.w	r0,r2
	cmp/hi	r3,r2
	bf	1b

	mov.l	MCR_A,r1	/* MCR Address */
	mov.l	MCR_D2,r0	/* MCR Data2 */
	mov.l	r0,@r1

	mov.l	SDMR3_A,r1	/* Set SDRAM mode */
	mov	#0,r0
	mov.b	r0,@r1

	mov.l	MMU_PTEA_A,r1	/* MMU PTEA Address */
	mov.l	MMU_PTEA_D,r0	/* MMU PTEA Data */
	mov.l	r0,@r1

	mov.l	IRLMASK_A,r1	/* IRLMASK Address */
	mov.l	IRLMASK_D,r0	/* IRLMASK Data */
	mov.l	r0,@r1

	mov.l	BOOT_CONFIG_WORD,r1
	mov.w	@r1,r0
	exts.b	r0,r0
	cmp/eq	#0xde,r0	! MAGIC # for "doDEs"
	bf	1f
	mov.l	0f,r5
	mov.l	0f,r6
	mov.l	0f,r7
	bra	1f
	 nop
	.align	2
0:	.long 0xbabeface
1:
	rts
	 nop

	.align	2

FRQCR_A:
	.long	0xFFC00000	/* FRQCR Address */
FRQCR_D:
	.long	0x00000e0a	/* 240.00:120.00:60.00 */
!	.long	0x00000e13	/* 120.00:40.00:20.00 */
!	.long	0x00000808	/* 20.00:10.00:10.00 */


BCR1_A:
	.long	0xFF800000	/* BCR1 Address */
BCR1_D:
	.long	0x00080009	/* Area 3 SDRAM */


BCR2_A:
	.long	0xFF800004	/* BCR2 Address */
BCR2_D:
	.long	0xaaf8		/*  */


BCR3_A:
	.long	0xFF800050	/* BCR3 Address */
BCR3_D:
!	.long	0x0000		/*  */
	.long	0x0001		/*  */


BCR4_A:
	.long	0xFE0A00F0	/* BCR4 Address */
BCR4_D:
	.long	0x00000011	/*  */


WCR1_A:
	.long	0xFF800008	/* WCR1 Address */
WCR1_D:
	.long	0x33333333	/*  */


WCR2_A:
	.long	0xFF80000C	/* WCR2 Address */
WCR2_D:
!	.long	0xCFFA6FBF	/*  */
!	.long	0xde7a6fbf
	.long	0xfffa6fbf


WCR3_A:
	.long	0xFF800010	/* WCR3 Address */
WCR3_D:
	.long	0x07577707	/*  */


LED_A:
	.long	0x0400000E	/* LED Address */


RTCNT_A:
	.long	0xFF800020	/* RTCNT Address */
RTCNT_D:
	.long	0xA500		/* RTCNT Write Code A5h Data 00h */


RTCOR_A:
	.long	0xFF800024	/* RTCOR Address */
RTCOR_D:
	.long	0xA534		/* RTCOR Write Code  */


RTCSR_A:
	.long	0xFF80001C	/* RTCSR Address */
RTCSR_D:
	.long	0xA510		/* RTCSR Write Code */


SDMR3_A:
!	.long	0xFF940330	/* SDMR3 Address */
!	.long	0xFF9400cc	/* SDMR3 Address */
	.long	0xFF9400c8	/* SDMR3 Address */
SMDR3_D:
	.long	0x55


MCR_A:
	.long	0xFF800014	/* MCR Address */
MCR_D1:
!	.long	0x080101F4	/* MRSET:'0' */
	.long	0x081901F4	/* MRSET:'0' */
MCR_D2:
!	.long	0x480101F4	/* MRSET:'1' */
	.long	0x481901F4	/* MRSET:'1' */


RFCR_A:
	.long	0xFF800028	/* RFCR Address */
RFCR_D:
	.long	0xA400		/* RFCR Write Code A4h Data 00h */


PCR_A:
	.long	0xFF800018	/* PCR Address */
PCR_D:
!	.long	0x4A53		/*  */
!	.long	0x4A08		/*  */
!	.long	0xdc63
!	.long	0x4c60
	.long	0x4b0c



MMU_PTEA_A:
	.long	0xFF000034	/* MMU PTEA Address */
MMU_PTEA_D:
	.long	0x00000005
MMUCCR_A:
	.long	0xff000010	/* MMUCCR Address */
MMUCCR_D:
	.long	0x00000000	/* MMUCCR Data */
IRLMASK_A:
	.long	0xa4000004	/* IRLMASK Address */
IRLMASK_D:
	.long	0x00000000	/* IRLMASK Data */


BOOT_CONFIG_WORD:
	.long	0xb0800000
